#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

typedef unsigned int uint;
typedef unsigned char uchar;

#define GC_BRGI 15
#define GC_BRG 7
#define GC_BR 3
#define GC_R 2
#define GC_B 1
#define PATTERN_BLUE 0
#define PATTERN_RED 1
#define PATTERN_GREEN 2
#define PATTERN_INTEN 3
#define PLANE_BLUE 1
#define PLANE_RED 2
#define TX_BLACK     0x00  /* 0x01 ij   0x01  */
#define TX_BLUE      0x01  /* 0x01 iȂj 0x21  */
#define TX_RED       0x02  /* 0x01 iȂj 0x41  */
#define TX_MAGENTA   0x03  /* 0xe1 ij   0x61  */
#define TX_GREEN     0x04  /* 0x61 ΁ij   0x81  */
#define TX_CYAN      0x05  /* 0x21 ij   0xa1  */
#define TX_YELLOW    0x06  /* 0xc1 ij   0xc1  */
#define TX_WHITE     0x07  /* 0x21 ij   0xe1  */
#define TX_REVERSE   0x08  /* ]                    */
#define TX_UNDERLINE 0x10  /*                     */

extern void my_sleep(void);
extern void my_bitblt(void);
extern char *pBits;
extern int play_on;
extern int flag_drop;
extern char filename[];

extern void draw_toon(void); /* 2003 */
extern void draw_tensen(void); /* 2003 */
extern void grcg_hline( int x1, int x2, int y );
extern void grcg_vline( int x, int y1, int y2 );
extern void grcg_boxfill( int x1, int y1, int x2, int y2 );
extern void grcg_byteboxfill_x( int x1, int y1, int x2, int y2 );
extern void grcg_setcolor( int mode, int color );
extern void grcg_off(void);
extern void xor_vline(int x, int y1, int y2); /* R G B 3v[XOR */
extern void super_put_1plane(int x, int y, int num, int pattern_plane,
                             unsigned put_plane );

void settempo(uint bias);
int key_check(void);

void sequence(void);
void check_key_off(void);     /*gate-1ēKXkey off*/
void check_key_on(void);

void usr_excl(void);      /* 90-97 UsrExc   */
void tr_excl(void);          /* 98 Tr.Excl  */
void rol_base(void);         /* dd RolBase  */
void rol_para(void);         /* de RolPara  */
void rol_dev(void);          /* df RolDev#  */
void bank_program(void);     /* e2 BankPrg  */
void midi_channel(void);     /* e6 MIDI CH. */
void ch_pressure(void);      /* ea AFTER C. */
void key_pressure(void);     /* ed AFTER K. */
void loop_end(void);         /* f8    ]     */
void loop_begin(void);       /* f9    [     */
void same_meas(void);        /* fc ======== */
void meas_end(void);         /* fd -------- */

void key_off_18tr(void);     /*LĂSĂnotenote off*/

void display_data(int k);
void set_data(void);
void next_data(void);
void prev_data(void);
void meas_top(void);

void set_key_on_off(uchar k);

void waku(void);
void draw_key_on(char k, uchar m);
void draw_key_off(char k, uchar m);
void draw_key_on_off(void);
int read_file(void);
void init_data(void);

uint tempo = 120;   /* e|(10`120`240) */
uint delta = 10417; /* usP (T=120̎ delta=10.417ms) */
int intc1;
int intc2;          /* 2003 */
uchar *fdata;

uint  drum_name[128];   /* hK#ƖO|C^̑Ή */

uchar  ons[18];         /* Ă鉹̐Bő16 */
uchar  r_step[18][16];  /* c蔭Xebv */
uchar  r_key[18][16];   /* Ăj */

int counts[18];
uchar *pointb[18];      /* egbÑx[X|Cg */
uchar *points[18];      /* egbÑJg|Cg */
uchar *pointc;          /* Jg|Cg */
int ctr;                /* JggbN */
char endfs[18];         /* GhtO */
int meass[18];
int measc;              /* Jgߔԍ */

char  play_bias;           /* SgbNΏۂK# */
uchar rhythm_mode[18];     /* Y on..0x80 off..0x00 */
uchar tr_ch[18];           /* gbNoCHΉ\ */
char  key_bias[18];        /* KEY#+l */
char  st_bias[18];         /* STl */
uchar tr_mode[18];         /* MODE (0:Play 1:Mute 2:Mix 4:Rec) */
                           /*      (8:MIDI CH.OFF 16:note֌WOFF) */
uchar rol_ex_data[18][11]; /* Roland Exclusive f[^ */

uchar *lp_s[18];     /* same measIĖ߂ʒuBOȂs.m.łȂ */
uchar *lp_l1[18][5]; /* [v̐擪i[̎j */
uchar *lp_l2[18][5]; /* s.m.[ꍇ́As.m.IĖ߂ʒu */
int  lp_l3[18][5]; /* [vJE^iOBJEgAbvj */
uint lp_l4[18][5]; /* [v擪̏ߔԍ */
uint lp_ln[18];    /* [vo^ */

char kenban_bias[18];       /* Ղ '<' '>' ł炷 */

int skip_tr;
int skip_point = 0;

uchar rec0, rec1, rec2, rec3;
int cur_mode;

uint force_flag = 0;   /* ^C}[tO */
uint force_count = 0;  /* ^C}[JEg */
int g_count = 0;     /* O[oJEg */

int hmm = 1;  /* ʃ[h         0:W 1:㔼 2: */
int hmy;      /* ʂ̊xW     200      0      200    */
int kby;      /* Ղ̊xW      50    184      184    */
int hmh = 1;  /* ʋɏ[h     0:W 1:ɔ(1/4) */
int hhy;      /* ʂ̊xW(1/4)200      0      200    */
int ftm = 0;  /* tHg[h     0:(8x16) 1:(8x8)     */
int mmm = 0;  /* [h         0:l\ 1:\    */

int shift;    /* VtgL[Q̏ */

int kbias = 0; /* K\p */
int kbias_chg = 0; /* ωP*/
uchar kbias_trans[16] = {0,7,2,9,4,11,6,1,0,5,10,3,8,1,6,11};
char *nn = "C C#D D#E F F#G G#A BbB ";
char *MMkey
       = "C G D A E B F#C#C F BbEbAbDbGbCbA E B F#C#G#D#A#A D G C F BbEbAb";
int disp_tr_c1 = 0;
int disp_tr_c2 = 1;

void text_putsa( int x, int y, char *str, int atrb );
void text_aputsa(int x, int y, char *s, int atr);
void text_aputsa1(int y, char *s);
void check_s_jis(void);
void midi_out(int data);
void midi_out_long(char *p, int n);
void dbg_disp(int i);
void dbg_str(char *p);
void display_angle(void);
void display_angle_sub(void);
void display_data_sub(int k, int yy);
void display_smemo(void);  /* \O\ */
void display_tmemo(void);
void display_waku(void);  /*ςȂƂ*/
void draw_angle(void);
void draw_kaimei(int l);       /* K */
int end_check(void);
void generate_tone_name(void);  /* gbN𐶐 */
int get_key(void);
void strcpy(char *p, char *q);
void vvline(void);
void vline_sub(void);
void make_afont_data(void); /* ptHgf[^쐬 */
void skip_to_the_count(void);  /* O[oJEg܂őSgbNi߂ */
void get_count(void);   /* f[^AhXO[oJEg߂ */
int play_init(void);
int play_loop(void);
uchar afont[8*160]; /* ptHg(8*8dot)160̃f[^ */
int ang0, ang1, ang2, ang3;
int meas_prev_disp;
int meas_prev_disp1 = -1;
int meas_prev_disp2 = -1;
int vline_x;
int vline_x1 = 0;
int vline_x2 = 0;
int cur_stv1 = 0;
int cur_stv2 = 0;
int sub_tr;
int sub_trb;
int sub_trb1;
int sub_trb2;

uint  gkeys[100];
uchar rgkey = 0;
uchar wgkey = 0;
uchar ngkey = 0;

int  meas;      /* ߐ(1`) */
int  step;      /* Xebv(1`) */
int  stv;       /* Xebvl(192Ȃ) */
int  cur_stv;   /* ĉXebvhbgʒu */
uchar *meas_st_ad;  /* ߐ擪AhX */
uchar *p;
char line_data[81];     /* Hobt@ */

int focus = 0;           /* ړ_ 0: 1: */
uchar *p_prev;
uchar *p_prev1;
uchar *p_prev2;
char stop;               /* 1ŕ\Xgbv */
char stop1 = 0;          /* 1ŕ\Xgbv */
char stop2 = 0;          /* 1ŕ\Xgbv */
int meas_prev;
int meas_prev1 = 1;
int meas_prev2 = 1;
int disp_tr = 0;       /*\gbN(0`17)*/
int disp_tr_c;
int disp_tr_prev;
int disp_tr_prev1 = -1;
int disp_tr_prev2 = -1;
int ftm_chg = 0;       /* tHg[hу[h؂ւ݂̂P */

int  image_num;

uchar nimage[] = {  /* W~cThbg */
0x3c, 0x62, 0x42, 0x46, 0x3c,    /* B:  */
0x1c, 0x3e, 0x7e, 0x7c, 0x38,    /* R:  */
0x50, 0xf8, 0x50, 0xf8, 0x50,    /* G:    */
0x00, 0x00, 0x00, 0x00, 0x00};   /* I: gp */

#if 1
uchar dimage1[] = {
0x26,0x20,0x20,0x38,0x26,0x20,0x20,0x20,  /* h */
0x20,0x20,0x20,0x20,0x21,0x22,0x2C,0x30,  /*  */
0x1C,0x03,0x00,0x1C,0x03,0x00,0x3C,0x03,  /* ~ */
0xFC,0x04,0x05,0x04,0x08,0x08,0x10,0x60}; /* t */

uchar dimage2[] = {
0x00,0x00,0xF0,0x10,0x60,0x40,0x40,0x80,  /* @ */
0x81,0x81,0x41,0x42,0x02,0x04,0x18,0x60,  /* \ */
0x3E,0x00,0x7F,0x01,0x01,0x02,0x0C,0x30,  /*  */
0x60,0x10,0xC1,0x21,0x02,0x04,0x18,0x60}; /* V */
#endif

#if 0
uchar dimage1[] = {
0x23,0x20,0x16,0x18,0x20,0x40,0x40,0x3E,  /*  */
0x20,0x24,0xEA,0x32,0x22,0x62,0xA3,0x22,  /*  */
0x78,0x0A,0x12,0x7A,0x96,0xA3,0x44,0x08,  /*  */
0x10,0x08,0x00,0x10,0x12,0x49,0x85,0x18}; /*  */

uchar dimage2[] = {
0x00,0x10,0x3C,0x10,0x3C,0x5A,0x72,0x0C,  /*  */
0x3E,0x04,0x18,0x7F,0x08,0x10,0x10,0x0E,  /*  */
0x1C,0x00,0x20,0x2E,0x31,0x21,0x02,0x0C,  /*  */
0x20,0x20,0x20,0x20,0x20,0x21,0x22,0x1C}; /*  */
#endif

int toon[] = {
0x1820,0x1820,0x3820,0x4820,0x4820,0xFF3F,0x9820,0xB820,
0xF020,0xFF3F,0xC021,0xC023,0x4027,0xFF3F,0xFC2E,0xAC2D,
0x262D,0xFF3F,0xA62C,0x2C26,0xF823,0xFF3F,0x1020,0x1020,
0x1020,0x9021,0xA023,0xC021,0x0020,0xFF3F,0xE023,0x3224,
0x182E,0xFF3F,0x1827,0x1A22,0x1820,0xFF3F,0x3020,0x6020,
0x8021};  /* gLAwL */

char *tone_name88[] = {
"Piano 1","Piano 2","Piano 3","Honky-tonk",
"E.Piano 1","E.Piano 2","Harpsichord","Clav.",
"Celesta","Glockenspiel","Music Box","Vibraphone",
"Marimba","Xylophone","Tubular-bell","Santur",
"Organ 1","Organ 2","Organ 3","Church Org.1",
"Reed Organ","Accordion Fr","Harmonica","Bandoneon",
"Nylon-str.Gt","Steel-str.Gt","Jazz Gt.","Clean Gt.",
"Muted Gt.","Overdrive Gt","DistortionGt","Gt.Harmonics",
"Acoustic Bs.","Fingered Bs.","Picked Bass","Fretless Bs.",
"Slap Bass 1","Slap Bass 2","Synth Bass 1","Synth Bass 2",
"Violin","Viola","Cello","Contrabass",
"Tremolo Str","PizzicatoStr","Harp","Timpani",
"Strings","Slow Strings","Syn.Strings1","Syn.Strings2",
"Choir Aahs","Voice Oohs","SynVox","OrchestraHit",
"Trumpet","Trombone","Tuba","MutedTrumpet",
"French Horns","Brass 1","Synth Brass1","Synth Brass2",
"Soprano Sax","Alto Sax","Tenor Sax","Baritone Sax",
"Oboe","English Horn","Bassoon","Clarinet",
"Piccolo","Flute","Recorder","Pan Flute",
"Bottle Blow","Shakuhachi","Whistle","Ocarina",
"Square Wave","Saw Wave","Syn.Calliope","Chiffer Lead",
"Charang","Solo Vox","5th Saw Wave","Bass & Lead",
"Fantasia","Warm Pad","Polysynth","Space Voice",
"Bowed Glass","Metal Pad","Halo Pad","Sweep Pad",
"Ice Rain","Soundtrack","Crystal","Atmosphere",
"Brightness","Goblin","Echo Drops","Star Theme",
"Sitar","Banjo","Shamisen","Koto",
"Kalimba","Bagpipe","Fiddle","Shanai",
"Tinkle Bell","Agogo","Steel Drums","Woodblock",
"Taiko","Melo. Tom 1","Synth Drum","Reverse Cym.",
"Gt.FretNoise","Breath Noise","Seashore","Bird",
"Telephone 1","Helicopter","Applause","Gun Shot"};

void sequence()
{
    int  i, st;

    if (skip_point)
        return;

    if (force_flag) {
        if (force_count > 0) force_count--;
        return;
    }

    g_count++;

    for (i = 0; i < 18; i++) {
        ctr = i;
        check_key_off();     /*128egate-1ēKXkey off*/
        counts[i]--;
        if (counts[i])
            continue;
        if (i == disp_tr_c1 || i == disp_tr_c2) intc1++;
        pointc = points[i];
        measc = meass[i];
        while (1) {
            cur_mode = tr_mode[i] & 0x19; /* Mix  Rec ̃tO͖ */
            if (cur_mode == 0)
                cur_mode = 2;           /* o͋KȂ*/
            else if (cur_mode == 16)
                cur_mode = 1;           /* o͋KiNOTE ON̂݁j*/
            else
                cur_mode = 0;           /* o͋KiׂĂMIDI OUTj*/

            rec0 = pointc[0];
            rec1 = pointc[1];
            rec2 = pointc[2];
            rec3 = pointc[3];

            if (rec0 < 0xf0)
              st = rec1;
            else
              st = 0;

            if (rec0 < 0x80) {
                check_key_on();
            }
            else if (rec0 >= 0x90 && rec0 <= 0x97) {
                usr_excl();                    /* USER EX1`8 */
            } else {
                switch (rec0) {
                  case 0x98:                   /*gbNGNXN[Vu*/
                    tr_excl();
                    break;
                  case 0xdd:                   /* Rol Base */
                    rol_base();
                    break;
                  case 0xde:                   /* Rol Para */
                    rol_para();
                    break;
                  case 0xdf:                   /* Rol Dev */
                    rol_dev();
                    break;
                  case 0xe2:                   /* Bank & Prog */
                    bank_program();
                    break;
                  case 0xe5:                   /* Key Scan */
                    break;
                  case 0xe6:                   /* MIDI Ch change */
                    midi_channel();
                    break;
                  case 0xe7:                   /*e|`FW*/
                    settempo(rec2);            /*graduation͖*/
                    break;
                  case 0xea:                   /* Ch Pressure */
                    ch_pressure();
                    break;
                  case 0xeb:                   /*Rg[`FW*/
                    midi_out(rec3 * 0x10000 + rec2 * 0x100 + 0xb0 + tr_ch[i]);
                    break;
                  case 0xec:                   /*vO`FW*/
                    midi_out(rec2 * 0x100 + 0xc0 + tr_ch[i]);
                    break;
                  case 0xed:                   /* Key Pressure */
                    key_pressure();
                    break;
                  case 0xee:                   /*sb`xh*/
                    midi_out(rec3 * 0x10000 + rec2 * 0x100 + 0xe0 + tr_ch[i]);
                    break;
                  case 0xf5:                   /* Key Change */
                    kbias = (12 - kbias_trans[rec1 % 16]) % 12;
                    kbias_chg = 1;
                    break;
                  case 0xf8:                   /* Loop End */
                    loop_end();
                    break;
                  case 0xf9:                   /* Loop Begin */
                    loop_begin();
                    break;
                  case 0xfc:                   /* Same Measure */
                    same_meas();
                    break;
                  case 0xfd:                   /* Measure End */
                    meas_end();
                    break;
                  case 0xfe:                   /*gbNGh*/
                    if (lp_s[ctr] != NULL) {
                        measc++;
                        pointc = lp_s[ctr];
                        lp_s[ctr] = NULL;
                        break;
                    }
                    endfs[ctr] = 1;
                    goto m1;
                }
            }
            pointc += 4;

            if (st == 0)
              continue;
            counts[i] = st;
            break;
        }
      m1:
        points[i] = pointc;
        meass[i] = measc;
    }
}

void check_key_on()
{
    uchar  i, j;

    if (skip_point) return;
    if (rec2 == 0) return;
    if (rec3 == 0) return;
    if (cur_mode == 0) return;

    if (key_bias[ctr] != (char)0x80)
        rec0 = (rec0 + play_bias + key_bias[ctr]) & 0x7f;

    j = 255;
    for (i = 0; i < 16; i++) {
        if (r_key[ctr][i] == rec0) {
            if (r_step[ctr][i] == 0) goto m1;
            goto m2;
        }
        if (j == 255 && r_step[ctr][i] == 0)
            j = i;
    }
    if (j == 255) return;
    i = j;
    r_key[ctr][i] = rec0;
  m1:
    set_key_on_off(rec0 | 0x80);
    midi_out(rec3 * 0x10000 + rec0 * 0x100 + 0x90 + tr_ch[ctr]);
    ons[ctr]++;
  m2:
    r_step[ctr][i] = rec2;
}

void check_key_off()     /*gate-1ēKXkey off*/
{
    uchar i, n, s;

    if (skip_point) return;
    i = 0;
    n = ons[ctr];
    while (n) {
        s = r_step[ctr][i];
        if (s != 0) {
            r_step[ctr][i] = s - 1;
            if (r_step[ctr][i] == 0) {
                set_key_on_off(r_key[ctr][i]);
                midi_out(r_key[ctr][i] * 0x100 + 0x90 + tr_ch[ctr]);
                ons[ctr] -= 1;
            }
            n--;
        }
        i++;
    }
}

void usr_excl() /* (90-97) */
{
    uchar sum = 0;
    int   sumstart = 0;
    int   i;
    uchar *p = fdata + 0x041e + (rec0 & 7) * 48;
    uchar buffer[256], a = 0;

    buffer[a++] = 0xf0;

    for (i = 0; i < 24; i++) {
        switch(p[i]) {
            case 0x80:
                buffer[a++] = rec2;
                if(sumstart == 1) sum += rec2;
                break;
            case 0x81:
                buffer[a++] = rec3;
                if(sumstart == 1) sum += rec3;
                break;
            case 0x82:
                buffer[a++] = tr_ch[ctr];
                if(sumstart == 1) sum += tr_ch[ctr];
                break;
            case 0x83:
                sumstart = 1;
                break;
            case 0x84:
                sum = (0x00 - sum) & 0x7f;
                buffer[a++] = sum;
                sumstart = 0;
                break;
            case 0xf7:
                goto m9;
            default:
                buffer[a++] = p[i];
                if(sumstart == 1) sum += p[i];
                break;
        }
    }
  m9:
    buffer[a++] = 0xf7;
    midi_out_long(buffer, a);
}

void tr_excl() /* (98) */
{
    uchar sum = 0;
    uchar value[2];
    int   sumstart = 0;
    int   j;
    uchar buffer[256], a = 0;

    pointc += 4;

    buffer[a++] = 0xf0;

    while (1) {
        if (pointc[0] != 0xf7) break;

        value[0] = pointc[2];
        value[1] = pointc[3];
        pointc += 4;

        for (j = 0; j < 2; j++) {
            switch (value[j]) {
                case 0x80:  /* gt */
                    buffer[a++] = rec2;
                    if (sumstart) sum += rec2;
                    break;
                case 0x81:  /* vel */
                    buffer[a++] = rec3;
                    if (sumstart) sum += rec3;
                    break;
                case 0x82:  /* ch */
                    buffer[a++] = tr_ch[ctr];
                    if (sumstart) sum += tr_ch[ctr];
                    break;
                case 0x83:  /* cs */
                    sumstart = 1;
                    break;
                case 0x84:  /* ss */
                    sum = (0x00 - sum) & 0x7f;
                    buffer[a++] = sum;
                    sumstart = 0;
                    break;
                case 0xf7:
                    goto m9;
                default:
                    buffer[a++] = value[j];
                    if (sumstart == 1) sum += value[j];
                    break;
            }
        }
    }
  m9:
    pointc -= 4;

    buffer[a++] = 0xf7;
    midi_out_long(buffer, a);
}

void rol_dev() /* (df) */
{
    rol_ex_data[ctr][2] = rec2;
    rol_ex_data[ctr][3] = rec3;
}

void rol_base() /* (dd) */
{
    rol_ex_data[ctr][5] = rec2;
    rol_ex_data[ctr][6] = rec3;
}

void rol_para() /* (de) */
{
    uchar sum = 0;
    int i;

    rol_ex_data[ctr][7] = rec2;
    rol_ex_data[ctr][8] = rec3;

    for (i = 5; i < 9; i++)
      sum += rol_ex_data[ctr][i];
    sum = (0x00 - sum) & 0x7f;
    rol_ex_data[ctr][9] = sum;

    midi_out_long(rol_ex_data[ctr], 11);
}

void bank_program() /* (e2) */
{
    uchar ch;

    ch = tr_ch[ctr];
    midi_out(rec3 * 0x10000 + 0x00 * 0x100 + 0xb0 + ch); /* bank */
    midi_out(0x00 * 0x10000 + 0x20 * 0x100 + 0xb0 + ch); /* bank low */
    midi_out(                 rec2 * 0x100 + 0xc0 + ch); /* program change */
}

void midi_channel() /* (e6) */
{
    uchar i, n;

    /* oZbg */
    i = 0;
    n = ons[ctr];
    while (n) {
        if (r_step[ctr][i] != 0) {
            r_step[ctr][i] = 0;
            set_key_on_off(r_key[ctr][i]);
            midi_out(0 * 0x10000 + r_key[ctr][i] * 0x100 + 0x90 + tr_ch[ctr]);
        }
        n--;
        i++;
    }
    ons[ctr] = 0;

    if (rec2 != 0) {
        tr_ch[ctr] = (rec2 - 1) & 0x0f;
        /* o͋K */
        tr_mode[ctr] &= 0x17;
    }
    else {
        /* o͋K */
        tr_mode[ctr] |= 0x08;
    }
}

void ch_pressure() /* (ea) */
{
    midi_out(rec2 * 0x100 + 0xd0 + tr_ch[ctr]);
}

void key_pressure() /* (ed) */
{
    midi_out(rec3 * 0x10000 + rec2 * 0x100 + 0xa0 + tr_ch[ctr]);
}

void loop_end() /* (f8) */
{
    int i = lp_ln[ctr];

    if (i == 0) return;  /* Ήloop beginȂ */
    i--;
    lp_l3[ctr][i]++;
    if ((lp_l3[ctr][i] & 0xff) != rec1) { /* [v */
        pointc = lp_l1[ctr][i];
        lp_s[ctr] = lp_l2[ctr][i];
        measc = lp_l4[ctr][i];
    }
    else {                                /* [v */
        lp_ln[ctr] = i;
    }
}

void loop_begin() /* (f9) */
{
    int i = lp_ln[ctr];

    if (i == 5) return;             /* [ṽlXg͂T܂ */
    lp_l1[ctr][i] = pointc;
    lp_l2[ctr][i] = lp_s[ctr];
    lp_l3[ctr][i] = 0;
    lp_l4[ctr][i] = measc;
    lp_ln[ctr] = i + 1;
}

void same_meas() /* (fc) */
{
    int value1, value2, i;

    if (lp_s[ctr] != NULL) {
        measc++;
        pointc = lp_s[ctr];
        lp_s[ctr] = NULL;
        return;
    }

    if ((pointc - pointb[ctr] != 0x2c) && (pointc[-4] < 0xfc))
        measc++;

    lp_s[ctr] = pointc;
    for (i = 0; i < 10; i++) {  /* same meas->same meas̒H10܂ */
        value1 = pointc[2];
        value2 = pointc[3];
        pointc = pointb[ctr] + ((value1 & 0xfc) | (value2 << 8));
        if (pointc[0] != 0xfc) {
            pointc -= 4;
            return;
        }
    }
    pointc = lp_s[ctr];  /* H莸s */
}

void meas_end() /* (fd) */
{
    measc++;
    if (lp_s[ctr] != NULL) {
        pointc = lp_s[ctr];
        lp_s[ctr] = NULL;
    }
}

void key_off_18tr()     /*LĂSĂnotenote off*/
{
    uint i, j;

    for (i = 0; i < 18; i++) {
        for (j = 0; j < 16; j++) {
            if (r_step[i][j] != 0) {
                midi_out(r_key[i][j] * 0x100 + 0x90 + tr_ch[i]);
                set_key_on_off(r_key[i][j]);
                draw_key_on_off();
            }
        }
    }
}

void waku()
{
    int  i, j;
    int  *p;
    char *p1;

    if (!hmm) {
        hmy = 200;
        kby = 50;
    }
    else {
        kby = 0;  /*384;*/
        if (hmm == 1)
            hmy = 24;  /*0;*/
        else
            hmy = 216; /*200;*/
    }
    kby = (hmm == 1) ? 208-32+1 : 208-32+1 + 192;

    grcg_setcolor(GC_BRGI, 0); /*GRCG̃[hѐFݒ 2003*/
    grcg_byteboxfill_x(240/8, hmy+8, 632/8, hmy+183); /* NA 2003*/

    grcg_setcolor(GC_BRGI, 4); /*GRCG̃[hѐFݒ*/
    grcg_hline(242, 639, (!hmm)?  48 : hmy+10);
    grcg_hline(242, 639, hmy+182);
    grcg_vline(242, (!hmm)? 48 : hmy+10, hmy+182);
    grcg_vline(639, (!hmm)? 48 : hmy+10, hmy+182);

    grcg_hline(242, 639, (!hmm)? 253 : hmy+117);

    draw_toon(); /* 2003 */

    draw_tensen(); /* 2003 */

    if (!hmm) {
        for (i = 120; i <= 144; i += 6)
            grcg_hline(242, 639, i);
        for (i = 156; i <= 180; i += 6)
            grcg_hline(242, 639, i);
        for (i = 321; i <= 561; i += 12)
            if ((i-321)%48)
                grcg_vline(i, 250, 253); /* 4hbgc */
            else
                grcg_vline(i, 247, 253); /* 7hbgc */
    }
    else {
        for (i = 44; i <= 60; i += 4)
            grcg_hline(242, 639, hmy+i);
        for (i = 68; i <= 84; i += 4)
            grcg_hline(242, 639, hmy+i);
        for (i = 321; i <= 561; i += 12)
            if ((i-321)%48)
                grcg_vline(i, hmy+115, hmy+116); /* 2hbgc */
            else
                grcg_vline(i, hmy+113, hmy+116); /* 1hbgc */
    }
    grcg_off();

    /* Ղ */
    grcg_setcolor(GC_BRG, 4); /*GRCG̃[hѐFݒ*/
    grcg_boxfill(254-2, kby, 254-2+10*7*5+10*3-1, kby+13*2);
    grcg_off();
    grcg_setcolor(GC_BRG, 0); /*GRCG̃[hѐFݒ*/
    for (i = 5; i <= 5*7*5+5*3; i += 5) {
        grcg_vline(253-2+i*2, kby, kby+13*2);
        if (i%(5*7) != 0 && i%(5*7) != 5*3)
            grcg_boxfill(250-2+i*2,kby, 256-2+i*2,kby+8*2);
    }
    grcg_boxfill(219 + 5*35,kby+26, 223 + 5*35,kby+26);  /* C4̐؂茇 */
    grcg_off();

    display_waku();  /*ςȂƂ*/
}

void draw_key_on(char k, uchar m)
{
    uchar l, h;
    int   kx, ky;

    if (m == 0)
        k = k + kenban_bias[disp_tr_c1];
    else
        k = k + kenban_bias[disp_tr_c2];
    if (k < 36)
        k = 35;
    else if (k > 100)
        k = 101;
    grcg_setcolor(GC_BRG, 0x07); /*GRCG̃[hѐFݒ*/
    l = k % 12;
    h = k / 12;
    if (l > 4) l++;
    kx = l / 2;
    ky = l % 2;
    kx = 254 + (h*35 - 35*3 + kx*5)*2 + ky*5;
    ky = 18 + 208-32+1 - ky*6*2 + 192*m;
    grcg_boxfill(kx, ky, kx+4, ky+7);
    grcg_off();
}

void draw_key_off(char k, uchar m)
{
    uchar l, h, f;
    int   kx, ky;

    if (m == 0)
        k = k + kenban_bias[disp_tr_c1];
    else
        k = k + kenban_bias[disp_tr_c2];
    f = 0;
    if (k < 36) {
        k = 35;
        f = 1;
    }
    else if (k > 100) {
        k = 101;
        f = 1;
    }
    l = k % 12;
    h = k / 12;
    if (l > 4) l++;
    kx = l / 2;
    ky = l % 2;
    if (ky || f)
        grcg_setcolor(GC_BRG, 0x00); /*GRCG̃[hѐFݒ*/
    else
        grcg_setcolor(GC_BRG, 0x04); /*GRCG̃[hѐFݒ*/
    kx = 254 + (h*35 - 35*3 + kx*5)*2 + ky*5;
    ky = 18 + 208-32+1 - ky*6*2 + 192*m;
    grcg_boxfill(kx, ky, kx+4, ky+7);
    grcg_off();
}

void set_key_on_off(uchar k)    /* bit7  on/off..1/0 */
{
    int a = k, f = 0;

    if (ctr == disp_tr_c2)
        a = a | 256;            /* bit8  /..0/1 */
    else if (ctr != disp_tr_c1)
        return;
  m1:
    if (ngkey > 100) return;
    ngkey++;
    gkeys[wgkey++] = a;
    if (wgkey >= 100) wgkey = 0;

    if (f == 0 && disp_tr_c1 == disp_tr_c2) {
        f = 1;
        a = k;
        goto m1;
    }
}

void draw_key_on_off()
{
    uint k;

    while (ngkey) {
        ngkey--;
        k = gkeys[rgkey];
        if (++rgkey >= 100) rgkey = 0;
        if (k & 0x80)
            draw_key_on(k & 0x7f, k >> 8);
        else
            draw_key_off(k, k >> 8);
    }
}

void display_waku()  /*ςȂƂ*/
{
    text_putsa( 0, 0, " RECOP Ver1.1 ",                 TX_YELLOW|TX_REVERSE);
    text_putsa(37, 1, " Memo ",                         TX_CYAN|TX_REVERSE);
    text_putsa(37,13, " Memo ",                         TX_CYAN);
    text_putsa( 0, 1, "MEAS STEP:NOTE K#  ST  GT VEL ", TX_GREEN|TX_UNDERLINE);
    text_putsa( 0,13, "MEAS STEP:NOTE K#  ST  GT VEL ", TX_GREEN|TX_UNDERLINE);
}

void display_data(int k)
{
    int k1, k2, i;

    k1 = k2 = k;
    if (k == 9) {  /* TAB */
        k1 = k2 = 0;
        focus = 1 - focus;  /* tH[JX؂ւ */
        if (!focus) {
            disp_tr = disp_tr_c1;
            text_putsa(37, 1, " Memo ", TX_CYAN|TX_REVERSE);
            text_putsa(37,13, " Memo ", TX_CYAN);
        }
        else {
            disp_tr = disp_tr_c2;
            text_putsa(37, 1, " Memo ", TX_CYAN);
            text_putsa(37,13, " Memo ", TX_CYAN|TX_REVERSE);
        }
    }
    else {
        if (!focus) {
            disp_tr_c1 = disp_tr;
            k2 = 0;
        }
        else {
            disp_tr_c2 = disp_tr;
            k1 = 0;
        }
    }

    if (k == 'f' || k == 'd') {  /* f */  /* d */
        grcg_setcolor(GC_BRGI, 0); /*GRCG̃[hѐFݒ*/
        grcg_byteboxfill_x(0/8, 16*2,  232/8, 16*25-1);
        grcg_off();
        if (mmm != 1 && k == 'f') {
            display_tmemo();    /* gbN */
            mmm = 1;
        }
        else if (mmm != 2 && k == 'd') {
            display_smemo();    /* \O */
            mmm = 2;
        }
        else {
            text_putsa( 0, 1, "MEAS STEP:NOTE K#  ST  GT VEL ",
                       TX_GREEN|TX_UNDERLINE);
            text_putsa( 0,13, "MEAS STEP:NOTE K#  ST  GT VEL ",
                       TX_GREEN|TX_UNDERLINE);
            k = 'g';  /* tricky */
            ftm = 1 - ftm;
            mmm = 0;
        }
    }
    ftm_chg = 0;
    if (k == 'g') {  /* g */
        if (mmm) return;
        ftm_chg = 1;
        if (!ftm) {
            for (i = 2; i < 25; i++) {
                if (i == 13) continue;
                text_putsa(0, i, "                              ", TX_WHITE);
            }
        }
        else {
            grcg_setcolor(GC_BRGI, 0); /*GRCG̃[hѐFݒ*/
            grcg_byteboxfill_x(0/8, 16*2,  232/8, 16*13-1);
            grcg_byteboxfill_x(0/8, 16*14, 232/8, 16*25-1);
            grcg_off();
        }
        ftm = 1 - ftm;          /* tHg[h؂ւ */
    }

    hmy = 24;
    stop = stop1;
    p_prev = p_prev1;
    meas_prev = meas_prev1;
    disp_tr_c = disp_tr_c1;
    disp_tr_prev = disp_tr_prev1;
    display_data_sub(k1,  2);
    stop1 = stop;
    p_prev1 = p_prev;
    meas_prev1 = meas_prev;
    disp_tr_prev1 = disp_tr_prev;

    hmy = 216;
    stop = stop2;
    p_prev = p_prev2;
    meas_prev = meas_prev2;
    disp_tr_c = disp_tr_c2;
    disp_tr_prev = disp_tr_prev2;
    display_data_sub(k2, 14);
    stop2 = stop;
    p_prev2 = p_prev;
    meas_prev2 = meas_prev;
    disp_tr_prev2 = disp_tr_prev;
}

void display_data_sub(int k, int yy)
{
    int  i, meas_bak, step_bak;
    uchar *p_cur, *q;
    int  lines = !ftm ? 11 : 19;
    int  tmpy;

    p = lp_s[disp_tr_c];
    if (p == 0) {              /* same measłȂ */
        p = points[disp_tr_c];
        if (!endfs[disp_tr_c])
            prev_data();  /* Ps߂(p̂) */
    }
    p_cur = p;

    switch (k) {
      case ' ':   /* Xy[XL[ */
        stop = 1 - stop;
        if (stop == 1)
            grcg_setcolor(GC_BRG, 0x03); /*GRCG̃[hѐFݒ*/
        else
            grcg_setcolor(GC_BRG, 0x00); /*GRCG̃[hѐFݒ*/
        tmpy = (yy == 2) ? 116 : 116+192;
        grcg_boxfill(244, tmpy, 249, tmpy+7);
        grcg_off();
        break;
      case 'n':   /* n */  /* ] */
        rhythm_mode[disp_tr_c] = rhythm_mode[disp_tr_c] ^ 0x80; /*Y 0x80*/
        break;
      case '<':   /* ՂPIN^[u */
        tmpy = kenban_bias[disp_tr_c];
        if (tmpy >= -12) kenban_bias[disp_tr_c] = tmpy - 12;
        kbias_chg = 1;
        break;
      case '>':   /* ՂPIN^[uE */
        tmpy = kenban_bias[disp_tr_c];
        if (tmpy <= 12*2) kenban_bias[disp_tr_c] = tmpy + 12;
        kbias_chg = 1;
        break;
      case 's':   /* s */
        force_flag = 1 - force_flag;
        if (force_flag == 1) {
            key_off_18tr();     /*LĂSĂnotenote off*/
            text_putsa(0, 0, "     Stop     ", TX_YELLOW|TX_REVERSE);
        }
        else {
            text_putsa(0, 0, " RECOP Ver1.1 ", TX_YELLOW|TX_REVERSE);
        }
        break;
      case 0x1e:  /*  */
        p = p_prev;
        meas = meas_prev;
        if (shift & 1) {
            meas_top();      /* pߐ擪AhXɖ߂ */
            prev_data();
            meas_top();      /* pߐ擪AhXɖ߂ */
        }
        else {
            prev_data();
        }
        p_prev = p;
        meas_prev = meas;
        break;
      case 0x1f:  /*  */
        p = p_prev;
        meas = meas_prev;
        if (shift & 1) {
            while (1) {
                if (p[0] >= 0xfe)
                    break;                     /* gbN */
                next_data();
                if (meas != meas_prev)
                    break;
            }
        }
        else {
            next_data();
        }
        p_prev = p;
        meas_prev = meas;
        break;
      case 0:     /* L[͂Ȃ */
      default:
        if (disp_tr_c == disp_tr_prev && (p_cur == p_prev || stop) && !ftm_chg)
            return;
        break;
    }

    if (disp_tr_prev != disp_tr_c || kbias_chg) {
        disp_tr_prev = disp_tr_c;
        /* gbNԍ\ */
        sprintf(line_data, "%2d ", disp_tr_c + 1);
        text_putsa(31, yy-1, line_data, TX_WHITE);

        /* gbN\ */
        p = pointb[disp_tr_c] + 0x0008;
        for (i = 0; i < 36; i++)
            line_data[i] = *p++;
        line_data[i] = 0;
        check_s_jis();
        text_putsa(44,yy-1, line_data, TX_YELLOW);

        /* Տ */
        for (i = 0; i < 127; i++)
            draw_key_off(i, (yy == 14));

        /* C4̐؂茇 */
        tmpy = (yy != 14) ? 203 : 395;
        grcg_setcolor(GC_BRG, 4); /*GRCG̃[hѐFݒ()*/
        for (i = 0; i <= 10*7*5; i += 10*7)
            grcg_hline(254+i,258+i,tmpy);
        grcg_setcolor(GC_BRG, 0); /*GRCG̃[hѐFݒ()*/
        i = (yy != 14) ? disp_tr_c1 : disp_tr_c2;
        i = ((kenban_bias[i]+60 - 36)/12)*10*7;
        grcg_hline(254+i,258+i,tmpy);
        grcg_off();

        goto m2;       /* gbNς~ʒuXV */
    }

    if (stop == 0) {
m2:
        p_prev = p_cur;
        meas_prev = meass[disp_tr_c];
    }
    if (mmm) return;  /* l\Ȃ */
    meas = meas_prev;
    p = p_prev;

    p_cur = p;
    for (i = 0; i < lines/2; i++)  /* T or XsOɖ߂ */
        prev_data();

    q = p;
    meas_top();      /* pߐ擪AhXɖ߂ */
    step = 1;        /*  */
    stv = 0;         /*  */
    while (p < q)    /* ʂɉf镔܂Ői߂ */
        next_data();
    step_bak = -1;   /*  */
    meas_bak = -1;   /*  */

    for (i = 0; i < lines; i++) {  /* 11 or 19 */
        set_data();
        if (p[0] == 0xfe)
            goto m1;
        if (meas != meas_bak)
            sprintf(&line_data[0], "%4d", meas);
        else
            sprintf(&line_data[0], "    ");
        if (step != step_bak || meas != meas_bak)
            sprintf(&line_data[4], " %4d", step);
        else
            sprintf(&line_data[4], "     ");
        meas_bak = meas;
        step_bak = step;
        line_data[9] = ':';

        if (p == p_cur) {
            if (!ftm)
                text_putsa(0, i+yy, line_data, TX_WHITE|TX_REVERSE);
            else
                text_aputsa(0, i+4, line_data, TX_WHITE|TX_REVERSE);
            cur_stv = stv;
        }
        else {
m1:         if (!ftm)
                text_putsa(0, i+yy, line_data, TX_CYAN);
            else
                text_aputsa(0, i+4, line_data, TX_CYAN);
        }
      /*text_locate(10, i);*/      /* J[\ʒu̕ύX */
        next_data();
    }
}

void set_data()
{
    int  k, s, g, v, i, d;
    char stp[4];
    char *cn;  /* control name */

    k = p[0];
    s = p[1];
    g = p[2];
    v = p[3];
    if (s == 0)
        sprintf(stp, "   ");
    else
        sprintf(stp, "%3d", s);
    if (k <= 0x7f) {
        if (g ==0 || v == 0) {
            sprintf(&line_data[10], "    ");
        }
        else {
            d = drum_name[k];
            if (d && (rhythm_mode[disp_tr_c] & 0x80)) { /* Y on..0x80 */
                for (i = 0; i < 7; i++) {
                    line_data[10 + i] = fdata[d + i];
                }
                if (v == 127)
                    d = 9;
                else
                    d = (v + 13) / 14;
                sprintf(&line_data[17], " %3s %3d ..%1d ", stp, g, d);
                return;
            }
            else {
                i = k % 12 * 2;
                line_data[10] = nn[i+0];
                line_data[11] = nn[i+1];
                i = k / 12 - 1;
                if (i < 0) {
                    line_data[12] = '-';
                    line_data[13] = '1';
                }
                else {
                    line_data[12] = '0' + i;
                    line_data[13] = ' ';
                }
            }
        }
        sprintf(&line_data[14], "%3d %3s %3d %3d ", k, stp, g, v);
        return;
    }
    if (k >= 0x90 && k <= 0x97) {  /* USER EX1`8 */
        sprintf(&line_data[10], "UsrExc%1d %3s %3d %3d ", k&7+1, stp, g, v);
        return;
    }
    switch (k) {
      case 0x98:  /*gbNGNXN[Vu*/
        sprintf(&line_data[10], "Tr.Excl %3s %3d %3d ", stp, g, v);
        return;
      case 0xdd:  /* Rol Base */
        sprintf(&line_data[10], "RolBase %3s %3d %3d ", stp, g, v);
        return;
      case 0xde:  /* Rol Para */
        sprintf(&line_data[10], "RolPara %3s %3d %3d ", stp, g, v);
        return;
      case 0xdf:  /* Rol Dev */
        sprintf(&line_data[10], "RolDev# %3s %3d %3d ", stp, g, v);
        return;
      case 0xe2:  /* Bank & Prog */
        sprintf(&line_data[10], "BankPrg %3s %3d %3d ", stp, g, v);
        return;
      case 0xe5:  /* Key Scan */
        sprintf(&line_data[10], "KeyScan %3s %3d     ", stp, g);
        return;
      case 0xe6:  /* MIDI Ch change */
        sprintf(&line_data[10], "MIDI CH.%3s ", stp);
        if (g == 0 || g > 32) {
            sprintf(&line_data[22], "OFF     ");
            return;
        }
        if (g < 17)
            line_data[22] = 'M';
        else {
            line_data[22] = 'R';
            g -= 16;
        }
        sprintf(&line_data[23], "%2d     ", g);
        return;
      case 0xe7:  /*e|`FW*/
        sprintf(&line_data[10], "TEMPO   %3s %3d %3d ", stp, g, v);
        return;
      case 0xea:  /* Ch Pressure */
        sprintf(&line_data[10], "AFTER C.%3s %3d     ", stp, g);
        return;
      case 0xeb:  /*Rg[`FW*/
        switch (g) {
          case 0x00:
          case 0x20: cn = "PG.BANK"; break;
          case 0x01: cn = "MODULAT"; break;
          case 0x05: cn = "PORTA T"; break;
          case 0x06: cn = "DATA(M)"; break;
          case 0x07: cn = "VOLUME "; break;
          case 0x0a: cn = "PANPOT "; break;
          case 0x0b: cn = "EXPRESS"; break;
          case 0x26: cn = "DATA(L)"; break;
          case 0x40: cn = "PEDAL  "; break;
          case 0x41: cn = "PORTAM "; break;
          case 0x42: cn = "SOSTEN "; break;
          case 0x43: cn = "SOFT   "; break;
          case 0x54: cn = "LEGART "; break;
          case 0x5b: cn = "REVERB "; break;
          case 0x5d: cn = "CHORUS "; break;
          case 0x62: cn = "NRPN(L)"; break;
          case 0x63: cn = "NRPN(M)"; break;
          case 0x64: cn = "RPN (L)"; break;
          case 0x65: cn = "RPN (M)"; break;
          case 0x78: cn = "AlSndOf"; break;
          case 0x79: cn = "RstAlCt"; break;
          case 0x7a: cn = "LoclCnt"; break;
          case 0x7b: cn = "AlNtOff"; break;
          default:   cn = "CONTROL"; break;
        }
        sprintf(&line_data[10], "%s", cn);
        sprintf(&line_data[17], " %3s %3d %3d ", stp, g, v);
        return;
      case 0xec:  /*vO`FW*/
        sprintf(&line_data[10], "PROGRAM %3s %3d     ", stp, g);
        return;
      case 0xed:  /* Key Pressure */
        sprintf(&line_data[10], "AFTER K.%3s %3d %3d ", stp, g, v);
        return;
      case 0xee:  /*sb`xh*/
        v = (v - 64) * 128 + g;
        if (v >= 0)
            sprintf(&line_data[10], "PITCH   %3s    %4d ", stp, v);
        else
            sprintf(&line_data[10], "PITCH   %3s   -%4d ", stp, -v);
        return;
      case 0xf5:  /* Music Key */
        sprintf(&line_data[10], "Music Key ");
        s = s & 0x001f;
        line_data[20] = MMkey[s*2];
        line_data[21] = MMkey[s*2+1];
        if (s < 16)
            sprintf(&line_data[22], "MAJOR   ");
        else
            sprintf(&line_data[22], "minor   ");
        return;
      case 0xf6:  /*Rg*/
        for (i = 0; i < 10; i++) {
            line_data[10 + i*2] = p[i*4 + 2];
            line_data[11 + i*2] = p[i*4 + 3];
        }
        line_data[30] = 0;
        check_s_jis();
        return;
      case 0xf8:  /* Loop End */
        sprintf(&line_data[10], "     ]  %3d         ", s);
        return;
      case 0xf9:  /* Loop Begin */
        sprintf(&line_data[10], "     [              ");
        return;
      case 0xfc:  /* Same Measure */
        sprintf(&line_data[10], "========%3d ======= ", s+((g&3)<<8)+1);
        return;
      case 0xfd:  /* Measure End */
        sprintf(&line_data[10], "------ %4d ------- ", stv);
        return;
      case 0xfe:  /*gbNGh*/
        for (i = 0; i < 30; i++) {
            line_data[i] = ' ';
        }
        line_data[i] = 0;
        return;
      default:
        sprintf(&line_data[10], "*** UNKNOWN ******* ");
    }
}

void next_data()       /* Ps(si) di:ߐ,bp:Xebvf */
{
    uchar k, k2, s;

    k = p[0];
    s = p[1];
    if (k >= 0xfe)
        return;                     /* gbN */
    p += 4;
    while ((k2 = p[0]) == 0xf7)     /* ZJhCxg΂ */
        p += 4;
    if (k >= 0xfc || k2 == 0xfc) {  /* same measure,(ߐ)̂Ƃ */
        meas_st_ad = p;        /* ߐ擪AhX */
        step = 1;              /* Xebv */
        stv = 0;
        meas++;                /* ߑ */
        return;
    }
    if (k >= 0xf0) {           /* f5:key change,f6:comment,f8:f9:loop */
        if (k != 0xf8)         /* f8:loop end */
            return;
        if (k2 >= 0xfc)        /* same measure,(ߐ)̂Ƃ */
            return;
        if (k2 == 0xf8)        /* f8:loop end */
            return;
        step++;                /* Xebv */
        return;
    }
    if (k2 == 0xfc)            /* same measure */
        return;
    stv += s;
    if (k2 == 0xf8)            /* f8:loop end */
        return;
    if (s == 0)                /* Xebvl0ȂOf[^ƂĂ */
        return;
    step++;                    /* Xebv */
    return;
}

void prev_data()               /* Ps߂(p̂) */
{
    uchar k;

    while (1) {
        if (p - pointb[disp_tr_c] == 0x2c)
            break;             /* gbN擪 */
        p -= 4;
        if (p[4] == 0xfc) {    /* same measurêƂ */
            meas--;
            break;
        }
        k = p[0];
        if (k >= 0xfc)         /* same measureAߐ̂Ƃ */
            meas--;
        if (k != 0xf7)         /* RgAGNXNVuȂǂ̌㔼H */
            break;
    }
    return;
}

void meas_top()                /* pߐ擪AhXɖ߂ */
{
    uchar *q;

    if (p[0] == 0xfc)          /* same measure? */
        return;
    while (1) {
        if (p - pointb[disp_tr_c] == 0x2c)
            break;             /* gbN擪 */
        if (p[-4] >= 0xfc)
            break;
        p -= 4;                /* same measure,ߐ,gbNłȂƂ*/
    }
    return;
}

int key_check()
{
    int  k;

    k = get_key();
    shift = k >> 8;
    k = k & 0xff;
    if (k >= '1' && k <= '8') {
        if (shift & 1)
            disp_tr = k - '0' +10 - 1;
        else
            disp_tr = k - '0' - 1;
    }
    else if (k >= 'A' && k <= 'Z') {
        k = k - 'A' + 'a';          /* 啶 */
    }
    switch (k) {
      case '9': disp_tr =  9 - 1; break;
      case '0': disp_tr = 10 - 1; break;
      case '!': disp_tr = 11 - 1; break;
      case '"': disp_tr = 12 - 1; break;
      case '#': disp_tr = 13 - 1; break;
      case '$': disp_tr = 14 - 1; break;
      case '%': disp_tr = 15 - 1; break;
      case '&': disp_tr = 16 - 1; break;
      case '\'':disp_tr = 17 - 1; break;
      case '(': disp_tr = 18 - 1; break;
    }
    return(k);
}

void display_angle()
{
    hmm = 1;
    hmy = 24;
    hhy = (hmh == 0) ? 24 : 24-32;
    stop = stop1;
    p_prev = p_prev1;
    meas_prev = meas_prev1;
    vline_x  = vline_x1;
    cur_stv  = cur_stv1;
    meas_prev_disp = meas_prev_disp1;
    sub_tr  = disp_tr_c1;
    sub_trb = sub_trb1;
    disp_tr_c = disp_tr_c1; /* ǉ2003 */
    display_angle_sub();
    vline_x1  = vline_x;
    cur_stv1  = cur_stv;
    meas_prev_disp1 = meas_prev_disp;
    sub_trb1 = sub_trb;

    hmm = 2;
    hmy = 216;
    hhy = (hmh == 0) ? 216 : 216-32;
    stop = stop2;
    p_prev = p_prev2;
    meas_prev = meas_prev2;
    vline_x  = vline_x2;
    cur_stv  = cur_stv2;
    meas_prev_disp = meas_prev_disp2;
    sub_tr  = disp_tr_c2;
    sub_trb = sub_trb2;
    disp_tr_c = disp_tr_c2; /* ǉ2003 */
    display_angle_sub();
    vline_x2  = vline_x;
    cur_stv2  = cur_stv;
    meas_prev_disp2 = meas_prev_disp;
    sub_trb2 = sub_trb;
}

void display_angle_sub()
{
    int  i, cur_meas;
    uchar *p_cur;

    p = lp_s[sub_tr];
    if (p == 0) {              /* same measłȂ */
        p = points[sub_tr];
        if (!endfs[sub_tr])
            prev_data();  /* Ps߂(p̂) */
    }

    if (stop == 0) {
        cur_meas = meass[sub_tr];  /* J[\ʒȕߔԍ */
    }
    else {
        cur_meas = meas_prev;
        p = p_prev;
    }
    p_cur = p;

    meas_top();      /* pߐ擪AhXɖ߂ */
    step = 1;
    stv = 0;
    while (p < p_cur)    /* Jg܂Ői߂ */
        next_data();
    cur_stv = stv;

    if (meas_prev_disp != cur_meas || sub_trb != sub_tr || kbias_chg) {
        meas_prev_disp = cur_meas;
        sub_trb = sub_tr;
        if (vline_x) {
            vline_sub();
            vline_x = 0;
        }
        grcg_setcolor(GC_BR, 0); /*GRCG̃[hѐFݒ*/
        if (hmm == 0)
            grcg_byteboxfill_x(240/8, 64, 632/8, 382);
        else if (hmh == 0)
            grcg_byteboxfill_x(240/8, hmy+8, 632/8, hmy+182);
        else
            grcg_byteboxfill_x(240/8, hmy+8, 632/8, hmy+182-32);

        if (stop == 1) {
            grcg_setcolor(GC_BRG, 0x03); /*GRCG̃[hѐFݒ*/
            i = (hmm == 1) ? 116 : 116+192;
            grcg_boxfill(244, i, 249, i+7);
        }
        grcg_off();

        draw_angle();

        i = (12 - kbias) % 12 * 2;
        line_data[0] = nn[i+0];
        line_data[1] = nn[i+1];
        line_data[2] = 0;
        text_putsa(32, (hmm == 1) ? 7 : 19, line_data, TX_WHITE);
    }
    vvline();
}

void draw_angle()
{
    int  st;
    uchar l, h;
    int   kx;
    int   xp = 0, yp;
    int   xt = 0, yt;
    int   xm = 0, ym;
    int   xv = 0, yv;
    int   xe = 0, ye;
    int   s = (hmm == 0) ? 1 : ((hmh == 0) ? 2 : 4);

    meas_top();      /* pߐ擪AhXɖ߂ */
    stv = 321;
    while (1) {
        ang0 = p[0];
        ang1 = p[1];
        ang2 = p[2];
        ang3 = p[3];

        if (ang0 < 0xf0)
            st = ang1;
        else
            st = 0;

        if (ang0 < 0x80 && ang2 && ang3) {
            ang3 /= s;
            grcg_setcolor(GC_B, 1); /*GRCG̃[hѐFݒ*/
            grcg_vline(stv, hhy+181-ang3, hhy+181);
            grcg_hline(stv, stv+ang2, hhy+181-ang3);
            grcg_vline(stv+ang2, hhy+181-ang3, hhy+181);
            grcg_off();
            kx = ang0;
            if (kx <  17) kx =  17;
            if (kx > 106) kx = 106;
            l = kx % 12;
            h = kx / 12;
            if (l > 4) l++;
            kx = l / 2;
            if (hmm == 0)
                kx = 253 - h*21 - kx*3;
            else
                kx = hmy + 132 - h*14 - kx*2;
            super_put_1plane(stv-3, kx,
                             0, PATTERN_RED, PLANE_BLUE); /*image_num=0*/
            draw_kaimei(l);
        }
        else {
            switch (ang0) {
              case 0xe7:                    /*e|`FW*/
                ang2 /= s;
                /*graduation͖*/
                if (xt) {
                    grcg_setcolor(GC_R, 2);
                    grcg_hline(xt, stv, yt);
                    grcg_vline(stv, yt, hhy+181-ang2);
                    grcg_off();
                }
                xt = stv;
                yt = hhy+181-ang2;
                break;
              case 0xeb:                    /*Rg[`FW*/
                ang3 /= s;
                if (ang2 ==  1) { /* MODULAT */
                    if (xm) {
                        grcg_setcolor(GC_BR, 3);
                        grcg_hline(xm, stv, ym);
                        grcg_vline(stv, ym, hhy+181-ang3);
                        grcg_off();
                    }
                    xm = stv;
                    ym = hhy+181-ang3;
                    break;
                }
                if (ang2 ==  7) { /* VOLUME  */
                    if (xv) {
                        grcg_setcolor(GC_R, 2);
                        grcg_hline(xv, stv, yv);
                        grcg_vline(stv, yv, hhy+181-ang3);
                        grcg_off();
                    }
                    xv = stv;
                    yv = hhy+181-ang3;
                    break;
                }
                if (ang2 == 11) { /* EXPRESS */
                    if (xe) {
                        grcg_setcolor(GC_BR, 3);
                        grcg_hline(xe, stv, ye);
                        grcg_vline(stv, ye, hhy+181-ang3);
                        grcg_off();
                    }
                    xe = stv;
                    ye = hhy+181-ang3;
                    break;
                }
                break;
              case 0xee:                    /*sb`xh*/
                ang3 /= s;
                if (xp) {
                    grcg_setcolor(GC_R, 2);
                    grcg_hline(xp, stv, yp);
                    grcg_vline(stv, yp, hhy+181-ang3);
                    grcg_off();
                }
                xp = stv;
                yp = hhy+181-ang3;
                break;
              case 0xf8:                    /* Loop End */
                break;
              case 0xf9:                    /* Loop Begin */
                break;
              case 0xfc:                    /* Same Measure */
              case 0xfd:                    /* Measure End */
                grcg_setcolor(GC_B, 1); /*GRCG̃[hѐFݒ*/
                if (s == 1) {
                    grcg_vline(stv, 121, 179);
                    grcg_vline(stv, 254, 381);
                }
                else {
                    grcg_vline(stv, hmy+ 45, hmy+ 83);
                    if (s == 2)
                        grcg_vline(stv, hmy+118, hmy+181);
                    else
                        grcg_vline(stv, hmy+118, hmy+181-32);
                }
                grcg_off();
                st = 10;
                break;
              case 0xfe:                    /*gbNGh*/
                goto m1;
            }
        }
        p += 4;
        stv += st;
        if (stv > 632) break;
    }
  m1: ;
}

void draw_kaimei(int l)       /* K */
{
    int shx;             /* txʒu */
    int patn, patp;      /* p^[ԍAv[ */
    int z;               /* ㉺炵ʁiቹj*/
    int k;               /* Kԍ */

    z = (l / 2) * 2;
    shx = 1; patn = 0; patp = PATTERN_BLUE;
    k = (ang0 + kbias) % 12;
    switch (k) {
      case  0: shx = 0;
      case  1:          patn = 1; patp = PATTERN_BLUE;  break;
      case  2: shx = 0;
      case  3:          patn = 1; patp = PATTERN_RED;   break;
      case  4: shx = 0; patn = 1; patp = PATTERN_GREEN; break;
      case  5: shx = 0;
      case  6:          patn = 1; patp = PATTERN_INTEN; break;
      case  7: shx = 0;
      case  8:          patn = 2; patp = PATTERN_RED;   break;
      case  9: shx = 0;
      case 10:          patn = 2; patp = PATTERN_GREEN; break;
      case 11: shx = 0; patn = 2; patp = PATTERN_INTEN; break;
    }
    if (ang0 >= 24 && ang0 <= 30)
        z = -1 - z;
    else if (ang0 >= 31 && ang0 <= 35)
        z = 14 - z;
    else
        z = 0;
    super_put_1plane(stv-3, hmy+96 + z,  /* 24 */
                     patn, patp, PLANE_RED); /* K */
    if (k == 5 || k == 6) { /* t@ */
        super_put_1plane(stv-3+8, hmy+96 + z,  /* 24 */
                         2, PATTERN_BLUE, PLANE_RED); /* K(@) */
        shx = shx * 3;
    }
    if (shx)
        super_put_1plane(stv-3+9, hmy+96 + z -shx,  /* 24 */
                         0, PATTERN_GREEN, PLANE_RED); /*  */
}

void vvline()
{
    if (vline_x == 321 + cur_stv)
        return;
    if (vline_x)
        vline_sub();
    vline_x = 321 + cur_stv;
    if (vline_x > 630)
        vline_x = 630;
    vline_sub();
}

void vline_sub()
{
    int y1, y2;

    if (!hmm)          { y1 =  64; y2 = 381;}
    else if (hmm == 1) { y1 =  35; y2 = 205;}  /*  11 181 */
    else               { y1 = 227; y2 = 397;}  /* 211 381 */
    if (hmh) y2 = y2 - 32;

    xor_vline(vline_x, y1, y2); /* R G B 3v[XOR */
}

void text_aputsa(int x, int y, char *s, int atr)
{
    void trans_code(uchar *p);
    int a;
    unsigned char *p;
    int i, j, fx, fy, c, c0, c1;

    trans_code(s);  /* R[hϊ */
    fx = x * 8;
    fy = y * 9 + hmy - 24;
    c = 0;
    if (atr & 1) c |= 0x01; /*  */
    if (atr & 2) c |= 0x02; /*  */
    if (atr & 4) c |= 0x04; /*  */
    c |= 8;
    if (atr & 8) {
        c1 = 0; /* eLXg̐FA */
        c0 = c; /* obN̐F */
    }
    else {
        c1 = c; /* eLXg̐F */
        c0 = 0; /* obN̐FA */
    }
    while (1) {
        a = *s++;
        if (a == 0) break;
        p = afont + (a-1) * 8;     /* ptHgf[^ */
        for (j = fy; j < fy + 8; j++) {
            for (i = fx; i < fx + 8; i++) {
                if (p[j-fy] & 1 << (7-i+fx))
                  c = c1;
                else
                  c = c0;
                pBits[640*(399-j)+i] = c;
            }
        }
        fx += 8;
    }
}

int play_init() /* 2003 */
{
    /* ʃNA */
    grcg_setcolor(GC_BRGI, 0x00); /*GRCG̃[hѐFݒ*/
    grcg_boxfill(0, 0, 639, 399);

    if (read_file() != 0) {
        text_putsa(0, 0, " RECOP Ver1.1 ", TX_YELLOW|TX_REVERSE);
        text_putsa(0, 2,
           "NɃt@Cw肳ĂȂAt@C`Ⴂ܂B",
           TX_WHITE);
        text_putsa(0, 3,
           "RCPt@C̃EChEɃhbOhbvĂB",
           TX_WHITE);
        my_bitblt();

        return(1);
    }

    hmm = 1;
    waku();
    hmm = 2;
    waku();

    disp_tr_prev1 = -1;
    disp_tr_prev2 = -1;
    vline_x1 = 0;
    vline_x2 = 0;
    cur_stv1 = 0;
    cur_stv2 = 0;

    init_data();
    generate_tone_name(); /* gbN𐶐 */
    intc1 = intc2 = 0;
    return(0);
}

int play_loop() /* 2003 */
{
    int i, tmp, k;

    my_sleep();

    for (i = 0; i < 18; i++) {
        if (!endfs[i]) goto m2;
    }
    return(9);
  m2:
    k = key_check();
    if (k == 'q') {key_off_18tr(); return(9);}
    if (k == 0x1b) {  /* ESC */
        key_off_18tr();     /*LĂSĂnotenote off*/
        force_flag = 1;
        if (end_check())
          return(9);
        force_flag = 0;
    }
    if (play_on == 0) { return(0);}
    if (k == ',') {kbias_chg = 1; kbias = (kbias + 11) % 12;}
    if (k == '.') {kbias_chg = 1; kbias = (kbias +  1) % 12;}
    if (k == 'a') {
        skip_point = 0x2c;
        skip_tr = 0;
        goto m5;
    }
    if (k == 'p') {
        if (!focus) {
            skip_point = p_prev1 - pointb[disp_tr_c1];
            skip_tr = disp_tr_c1;
        }
        else {
            skip_point = p_prev2 - pointb[disp_tr_c2];
            skip_tr = disp_tr_c2;
        }
      m5:
        text_putsa(0, 0, " Searching... ", TX_YELLOW|TX_REVERSE);

        key_off_18tr();     /*LĂSĂnotenote off*/
        /*goto m3;*/

        init_data();
        settempo(64);

        {
            int l;
            /* f[^AhXO[oJEg߂ */
            get_count();
            l = g_count;
            init_data();
            g_count = l;
        }
        /* same measAloop֘A */
        lp_s[skip_tr] = NULL;
        lp_ln[skip_tr] = 0;

        /* O[oJEg܂őSgbNi߂ */
        skip_to_the_count();
        text_putsa(0, 0, " RECOP Ver1.1 ", TX_YELLOW|TX_REVERSE);
        goto m4;
    }
    tmp = intc1;  /* intc2ւ̑܂łɃ^C}[݂ꍇl */
    if (k == 0 && tmp == intc2)
      return(0);
    intc2 = tmp;
    /* ʕ` */
    draw_key_on_off();
    display_data(k);
    display_angle();
    kbias_chg = 0;

    my_bitblt();
  m4:
    return(0);
}

void play_main()
{
    int a, i;

    make_afont_data();

    play_on = 0;
    if (play_init() == 0)
      play_on = 1;
    while (1) {
        a = play_loop();
        if (a == 9) break;
        if (flag_drop == 1) {
            flag_drop = 0;
            play_on = 0;
            if (play_init() == 0)
              play_on = 1;
        }
    }
}

int read_file()
{
    struct stat sbuf;
    int n, i;
    FILE *fp;

    if (filename[0] == 0) return(1); /* NɃt@ChbOȂ */
    stat(filename, &sbuf);
    n = sbuf.st_size;
    if (n == 0) return(1); /* ̃t@C̓fBNg */
    fdata = malloc(n);
    fp = fopen(filename, "rb");
    fread(fdata, n, 1, fp);
    fclose(fp);
    {
        char *p = "RCM-PC98V2.0(C)COME ON MUSIC";

        for (i = 0; i < 28; i++) {
            if (fdata[i] != p[i]) {
                return(1);
            }
        }
    }
    return(0);
}

void init_data()
{
    int   i, j;
    int   min = 384;
    uchar *mem, *p;

    tempo = fdata[0x01c1];
    settempo(64); /* bias 0ŃZbg */
    play_bias = fdata[0x01c5];
    kbias = (12 - kbias_trans[fdata[0x01c4] % 16]) % 12;

    for (i = 0; i < 128; i++) {
        drum_name[i] = 0;
    }
    for (i = 0; i < 32; i++) {
        drum_name[fdata[0x0214+i*16]] = 0x0206+i*16;
    }

    for (i = 0; i < 18; i++) {
        if (i == 0)
          pointb[0] = fdata + 0x0586;
        else
          pointb[i] = pointb[i-1] + *(pointb[i-1]+0) + *(pointb[i-1]+1)*256;
        points[i] = pointb[i]+ 0x002c; /*egbN̊Jnʒu*/
        mem = pointb[i];
        rhythm_mode[i] = mem[3];    /* Y on..0x80 off..0x00 */
        tr_ch[i] = mem[4] & 0x0f;   /* `lԍ M1`16R1`16ꎋ */
        key_bias[i] = mem[5];       /* KEY#+l */
        st_bias[i] = mem[6];        /* STl */
        tr_mode[i] = mem[7];        /* MODE (0:Play 1:Mute 2:Mix 4:Rec) */
        counts[i] = st_bias[i];     /* STl */

        if (mem[6] < 128) counts[i] = mem[6] + 256;
        meass[i] = 1;
        endfs[i] = 0;

        rol_ex_data[i][0]  = 0xf0;
        rol_ex_data[i][1]  = 0x41;
        rol_ex_data[i][2]  = 0x10;
        rol_ex_data[i][3]  = 0x16;
        rol_ex_data[i][4]  = 0x12;
        rol_ex_data[i][5]  = 0x10;
        rol_ex_data[i][6]  = 0x00;
        rol_ex_data[i][7]  = 0x00;
        rol_ex_data[i][8]  = 0x00;
        rol_ex_data[i][9]  = 0x00;
        rol_ex_data[i][10] = 0xf7;

        /* note on/offǗz񏉊 */
        ons[i] = 0;
        for (j = 0; j < 16; j++) {
            r_step[i][j] = 0;
            r_key[i][j] = 0;
        }

        /* same measAloop֘A */
        lp_s[i] = NULL;
        lp_ln[i] = 0;

        /* ŏl߂ */
        if (min > counts[i])
            min = counts[i];
    }

    for (i = 0; i < 18; i++) {
        counts[i] = counts[i] - min + 10;  /* 10:傢Ɨ]T܂ */
    }
    g_count = 0;                           /* O[oJEg */

    /* ^Cg\ */
    p = &fdata[0x0020];
    line_data[0] = ' ';
    for (i = 1; i < 65; i++) {
         j = *p++;
         line_data[i] = (j == 0) ? ' ' : j;
    }
    line_data[i++] = ' ';
    line_data[i] = 0;
    check_s_jis();
    text_putsa(14,0, line_data, TX_WHITE|TX_REVERSE);
}

void display_tmemo()
{
    int   i, j, k;
    char  *p;

    for (i = 0; i < 30; i++)
        line_data[i] = ' ';
    line_data[i] = 0;
    for (i = 1; i < 6; i++)
        text_putsa(0,i, line_data, TX_WHITE);
    text_putsa(0,6, "  -------- TRACK MEMO ------- ", TX_REVERSE|TX_GREEN);
    for (i = 0; i < 18; i++) {
        p = pointb[i] + 8;  /* C 2003 */
        sprintf(&line_data[0], "%2d", i+1);
        text_putsa(0,i+7, line_data, TX_REVERSE|TX_GREEN);
        line_data[0] = ' ';
        for (j = 1; j < 27; j++) {
             k = *p++;
             line_data[j] = (k == 0) ? ' ' : k;
        }
        line_data[j++] = ' ';
        line_data[j] = 0;
        check_s_jis();
        text_putsa(2,i+7, line_data, TX_WHITE);
    }

    /* OtBbNɕ` */
    grcg_setcolor(GC_BR, 3);
    grcg_vline(30*8-1, 7*16, 25*16-1);
    grcg_hline(0, 30*8-1, 25*16-1);
    grcg_off();
}

void display_smemo()  /* \O\ */
{
    int   i, j, k;
    char  *p;

    for (i = 0; i < 30; i++)
        line_data[i] = ' ';
    line_data[i] = 0;
    for (i = 1; i < 12; i++)
        text_putsa(0,i, line_data, TX_WHITE);

    hmy = 0;
    text_aputsa1( 7, "----- KEY FUNCTION ----");
    text_aputsa1( 9, "  ESC    quit(+SHIFT)");
    text_aputsa1(10, "   A     start again");
    text_aputsa1(11, "   S     song stop");
    text_aputsa1(12, "   D     song memo");
    text_aputsa1(13, "   F     track memo");
    text_aputsa1(14, "   G     change font");
    text_aputsa1(15, "   N     rhythm name");
    text_aputsa1(16, "   P     point play");
    text_aputsa1(17, "  TAB    focus exchange");
    text_aputsa1(18, "  0-9    track change");
    text_aputsa1(19, "  , .    key shift");
    text_aputsa1(20, "  < >    keyboard shift");
    text_aputsa1(21, " SPACE   flow stop");
    text_aputsa1(22, " cursor  line up/down");

    text_putsa(0,12, " --------- SONG MEMO -------- ", TX_REVERSE|TX_GREEN);

    p = fdata + 0x0060;  /* C 2003 */
    for (i = 0; i < 12; i++) {
        text_putsa(0,i+13, " ", TX_REVERSE|TX_GREEN);
        for (j = 0; j < 28; j++) {
             k = *p++;
             line_data[j] = (k == 0) ? ' ' : k;
        }
        line_data[j++] = ' ';
        line_data[j] = 0;
        check_s_jis();
        text_putsa(1,i+13, line_data, TX_WHITE);
    }

    /* OtBbNɕ` */
    grcg_setcolor(GC_BR, 3);
    grcg_vline(30*8-1, 13*16, 25*16-1);
    grcg_hline(0, 30*8-1, 25*16-1);
    grcg_off();
}

void text_aputsa1(int y, char *s)
{
    strcpy(line_data, s);
    text_aputsa(4, y, line_data, TX_CYAN);
}

/* VtgihrPڂŕ񂪏IĂA؂̂Ă */
void check_s_jis()
{
    uint  a;
    uchar *p;

    p = line_data;
    while (1) {
        a = *p++;
        if (a == 0) return;
        if (a < 0x80 || a >= 0xa0 && a < 0xe0) continue;
        if (*p == 0) {
            p--;
            *p = ' ';
            return;
        }
        p++;
    }
}

/* R[hϊ */
void trans_code(uchar *p)
{
    uint  a;

    while (1) {
        a = *p;
        if (a == 0) return;
        if (a < 0x20) {               /* Rg[*/
            *p++ = 0x7f-0x20+1;
            continue;
        }
        if (a < 0x80) {               /* p*/
            *p++ = a - 0x20+1;
            continue;
        }
        if (a >= 0xa0 && a < 0xe0) {  /* Ji*/
            *p++ = a - 0x40+1;
            continue;
        }                             /* */
        *p++ = 0x7f-0x20+1;
        if (*p == 0) return;
        *p++ = 0x7f-0x20+1;
    }
}

void get_count()   /* f[^AhXO[oJEg߂ */
{
    ctr = skip_tr;
    g_count = counts[ctr];
    pointc = points[ctr];
    while (1) {
        if (pointc - pointb[ctr] >= skip_point)
            break;
        rec0 = pointc[0];
        rec1 = pointc[1];
        if (rec0 < 0xf0) {
            g_count += rec1;
            pointc += 4;
            continue;
        }
        rec2 = pointc[2];
        rec3 = pointc[3];
        switch (rec0) {
          case 0xf8:                    /* Loop End */
            loop_end();
            break;
          case 0xf9:                    /* Loop Begin */
            loop_begin();
            break;
          case 0xfc:                    /* Same Measure */
            same_meas();
            break;
          case 0xfd:                    /* Measure End */
            meas_end();
            break;
          case 0xfe:                    /*gbNGh*/
            if (lp_s[ctr] != NULL) {
                pointc = lp_s[ctr];
                lp_s[ctr] = NULL;
                break;
            }
            goto m1;
        }
        pointc += 4;
    }
  m1:;
}

void skip_to_the_count()  /* O[oJEg܂őSgbNi߂ */
{
    int i, st, target_g_count;
    int  pit2[18], pit3[18], con1[18], con7[18], con10[18], con11[18];

    /* Տ */
    for (i = 0; i < 127; i++) {
        draw_key_off(i, 0);
        draw_key_off(i, 1);
    }

    for (i = 0; i < 18; i++)
      pit2[i] =pit3[i] = con1[i] = con7[i] = con10[i] = con11[i] = -1;

    init_data();
    get_count(); /* f[^AhXO[oJEg߂ */
    target_g_count = g_count;
    init_data();

    while (g_count < target_g_count - 1) {
        g_count++;

        for (i = 0; i < 18; i++) {
            ctr = i;
            counts[i]--;
            if (counts[i])
              continue;
            pointc = points[i];
            measc = meass[i];
            while (1) {
                cur_mode = tr_mode[i] & 0x19;  /* Mix  Rec ̃tO͖ */
                if (cur_mode == 0)
                  cur_mode = 2;           /* o͋KȂ*/
                else if (cur_mode == 16)
                  cur_mode = 1;           /* o͋KiNOTE ON̂݁j*/
                else
                  cur_mode = 0;           /* o͋KiׂĂMIDI OUTj*/

                rec0 = pointc[0];
                rec1 = pointc[1];
                rec2 = pointc[2];
                rec3 = pointc[3];

                if (rec0 < 0xf0)
                  st = rec1;
                else
                  st = 0;

                if (rec0 < 0x80) {
                    ;  /*check_key_on();*/
                }
                else if (rec0 >= 0x90 && rec0 <= 0x97) {
                    usr_excl();                    /* USER EX1`8 */
                } else {
                    switch (rec0) {
                      case 0x98:                   /*gbNGNXN[Vu*/
                        tr_excl();
                        break;
                      case 0xdd:                   /* Rol Base */
                        rol_base();
                        break;
                      case 0xde:                   /* Rol Para */
                        rol_para();
                        break;
                      case 0xdf:                   /* Rol Dev */
                        rol_dev();
                        break;
                      case 0xe2:                   /* Bank & Prog */
                        bank_program();
                        break;
                      case 0xe5:                   /* Key Scan */
                        break;
                      case 0xe6:                   /* MIDI Ch change */
                        midi_channel();
                        break;
                      case 0xe7:                   /*e|`FW*/
                        settempo(rec2);            /*graduation͖*/
                        break;
                      case 0xea:                   /* Ch Pressure */
                        ch_pressure();
                        break;
                      case 0xeb:                   /*Rg[`FW*/
                        switch (rec2) {
                          case   1: con1[i] = rec3; break;
                          case   7: con7[i] = rec3; break;
                          case  10: con10[i]= rec3; break;
                          case  11: con11[i]= rec3; break;
                          case   6:
                          case  98:
                          case  99:
                          case 100:
                          case 101:
                          case 121:
                          case 126:
                          case 127:
                          case  64:         /* _p[ */
                          case   0:         /* bank select */
                          case  32:         /* bank select */
                          case  91:         /* reverb */
                          case  93:         /* chorus */
                            goto m2;
                          default:
                          m2:
                            midi_out(rec3 * 0x10000 + rec2 * 0x100
                                     + 0xb0 + tr_ch[i]);
                        }
                        break;
                      case 0xec:                   /*vO`FW*/
                        midi_out(rec2 * 0x100 + 0xc0 + tr_ch[i]);
                        break;
                      case 0xed:                   /* Key Pressure */
                        key_pressure();
                        break;
                      case 0xee:                   /*sb`xh*/
                        pit2[i] = rec2;
                        pit3[i] = rec3;
                        break;
                      case 0xf5:                   /* Key Change */
                        kbias = (12 - kbias_trans[rec1 % 16]) % 12;
                        kbias_chg = 1;
                        break;
                      case 0xf8:                   /* Loop End */
                        loop_end();
                        break;
                      case 0xf9:                   /* Loop Begin */
                        loop_begin();
                        break;
                      case 0xfc:                   /* Same Measure */
                        same_meas();
                        break;
                      case 0xfd:                   /* Measure End */
                        meas_end();
                        break;
                      case 0xfe:                   /*gbNGh*/
                        if (lp_s[ctr] != NULL) {
                            measc++;
                            pointc = lp_s[ctr];
                            lp_s[ctr] = NULL;
                            break;
                        }
                        endfs[ctr] = 1;
                        goto m1;
                    }
                }
                pointc += 4;

                if (st == 0)
                  continue;
                counts[i] += st;
                break;
            }
          m1:
            points[i] = pointc;
            meass[i] = measc;
        }
    }

    for (i = 0; i < 18; i++) {
        if (pit2[i] != -1)
          midi_out(pit3[i] * 0x10000 + pit2[i] * 0x100 + 0xe0 + tr_ch[i]);
        if (con1[i] != -1)
          midi_out(con1[i] * 0x10000 + 1 * 0x100 + 0xb0 + tr_ch[i]);
        if (con7[i] != -1)
          midi_out(con7[i] * 0x10000 + 7 * 0x100 + 0xb0 + tr_ch[i]);
        if (con10[i] != -1)
          midi_out(con10[i] * 0x10000 + 10 * 0x100 + 0xb0 + tr_ch[i]);
        if (con11[i] != -1)
          midi_out(con11[i] * 0x10000 + 11 * 0x100 + 0xb0 + tr_ch[i]);
    }

    skip_point = 0;
}

void generate_tone_name()  /* gbN𐶐 */
{
    uchar *p;
    int   i, j, k, n;
    uchar pg[10], a, f, *q;

    for (i = 0; i < 18; i++) {
        p = pointb[i];  /* C 2003 */
        for (j = 0x0008; j < 0x2c; j++) {
            a = p[j];
            if (a != ' ' && a != 0 && a != 255)
                goto m2;
        }
        n = 0;
        f = 0;
        while (1) {
            a = p[j];
            if (a >= 0xfe)
                goto m1;
            if (a < 0x80) {
                if (p[j+2] != 0 && p[j+3] != 0)
                    f |= 1;
            }
            if (a == 0xec) {  /* vO`FW */
                for (k = 0; k < n; k++) {
                    if (p[j+2] == pg[k])
                        goto m3;
                }
                pg[n++] = p[j+2];
                if (n == 10)
                    goto m1;
            }
          m3:
            j += 4;
        }
      m1:
        j = 0x0008;
        if (n == 0 && f == 1) {  /* prg chgȂ */
            q = "sound";
            for (k = 0; k < 5; k++)
                p[j++] = *q++;
            goto m2;
        }
        /* Fɕϊ */
        k = 0;
        while (k < n && j < 0x2c) {
            if (k != 0)
                p[j++] = '/';      /* ؂ */
            q = tone_name88[pg[k]];
            while (*q != 0 && j < 0x2c)
                p[j++] = *q++;
            k++;
        }
      m2:;
    }
}

int end_check()
{
    int a;

    if (shift & 1)     /* Vtg */
        return(1);
    text_putsa(0, 0, "  End? [Y/N]  ", TX_YELLOW|TX_REVERSE);
    my_bitblt();
    while (1) {
        a = key_check();  /* ҂ȂL[ */
        if (a == 'Y' || a == 'y')
            return(1);
        if (a != 0)
            break;
        my_sleep();
    }
    text_putsa(0, 0, " RECOP Ver1.1 ", TX_YELLOW|TX_REVERSE);
    my_bitblt();
    return(0);
}

void settempo(uint bias)
{
    /*e|^C}荞ݎZbg*/
    uint tmp;

    tmp = (tempo * bias + 33) / 64;  /* { 32 {ƍ킹 33 */
                                     /* (65*95/64 = 96.484  97 ɂȂ) */
    if (tmp < 10)  tmp = 10;
    if (tmp > 240) tmp = 240;
    delta = (12500000 / tmp + 5 ) / 10; /*SPʂ̎ԊԊuAľܓl*/
}

void make_afont_data() /* ptHgf[^쐬 */
{
    int i, j, x, y, cx, cy, a;
    char *p = afont;

    line_data[0x20] = 0;
    for (i = 0; i < 0x20; i++) line_data[i] = i+0x20;
    text_putsa(0, 0, line_data, TX_WHITE);
    for (i = 0; i < 0x20; i++) line_data[i] = i+0x40;
    text_putsa(0, 1, line_data, TX_WHITE);
    for (i = 0; i < 0x20; i++) line_data[i] = i+0x60;
    text_putsa(0, 2, line_data, TX_WHITE);
    for (i = 0; i < 0x20; i++) line_data[i] = i+0xa0;
    text_putsa(0, 3, line_data, TX_WHITE);
    for (i = 0; i < 0x20; i++) line_data[i] = i+0xc0;
    text_putsa(0, 4, line_data, TX_WHITE);

    for (j = 0; j < 5; j++) {
        for (i = 0; i < 0x20; i++) {
            for (y = 0; y < 8; y++) {
                a = 0;
                for (x = 0; x < 8; x++) {
                    cx = i*8 + x;
                    cy = j*16 + y*2;
                    a = a << 1;
                    if (pBits[640*(399-cy)+cx] || pBits[640*(399-cy-1)+cx])
                      a |= 1;
                }
                *p++ = a;
            }
        }
    }

    p = &afont[(0x7f - 0x20) * 8]; /* delR[h̃tHgԖږ͗lɕύX */
    *p++ = 0x54;
    *p++ = 0x2a;
    *p++ = 0x54;
    *p++ = 0x2a;
    *p++ = 0x54;
    *p++ = 0x2a;
    *p++ = 0x54;
    *p =   0x00;

    /* ʃNA */
    grcg_setcolor(GC_BRGI, 0x00); /*GRCG̃[hѐFݒ*/
    grcg_boxfill(0, 0, 639, 399);
}
