extern void hline(int, int, int, int c);
extern void vline(int, int, int, int c);
extern char *pBits;
extern unsigned char nimage[], dimage1[], dimage2[];
extern int hmy;      /* ʂ̊xW     200      0      200    */
extern int toon[];

int gc_and, gc_or;

void grcg_setcolor( int mode, int color )
{
    gc_and = (0xff ^ mode) & 0x0f;
    gc_or = mode & color;
}

void gc_hline(int x1, int x2, int y)
{
    int i;
    char a;

    if (x1 > 639 || y > 399) return;
    if (x2 > 639) x2 = 639;
    for (i = x1; i <= x2; i++) {
        a = pBits[640*(399-y)+i] & gc_and;
        pBits[640*(399-y)+i] = a | gc_or;
    }
}

void gc_vline(int x, int y1, int y2)
{
    int i;
    char a;

    if (x > 639 || y1 > 399) return;
    if (y2 > 399) y2 = 399;
    for (i = y1; i <= y2; i++) {
        a = pBits[640*(399-i)+x] & gc_and;
        pBits[640*(399-i)+x] = a | gc_or;
    }
}

void grcg_hline( int x1, int x2, int y )
{
    gc_hline(x1, x2, y);
}

void grcg_vline( int x, int y1, int y2 )
{
    gc_vline(x, y1, y2);
}

void grcg_boxfill( int x1, int y1, int x2, int y2 )
{
    int i;

    for (i = y1; i <= y2; i++) {
        gc_hline(x1, x2, i);
    }
}

void grcg_byteboxfill_x( int x1, int y1, int x2, int y2 )
{
    int i;

    for (i = y1; i <= y2; i++) {
        gc_hline(x1*8, x2*8+7, i);
    }
}

void grcg_off(void)
{
}

void xor_vline(int x, int y1, int y2) /* R G B 3v[XOR */
{
    int i;

    for (i = y1; i <= y2; i++) {
        pBits[640*(399-i)+x] ^= 0x07;
    }
}

void
super_put_1plane(int x, int y, int num, int pattern_plane, unsigned put_plane )
{
    unsigned char *p;
    int a, i, j, dy;

    switch(num) {
      case 0: p = nimage;  dy = 5; break;
      case 1: p = dimage1; dy = 8; break;
      case 2: p = dimage2; dy = 8; break;
    }
    p += dy * pattern_plane;

    for (j = y; j < y + dy; j++) {
        for (i = x; i < x + 8; i++) {
            if (p[j-y] & 1 << (7-i+x))
              pBits[640*(399-j)+i] |= put_plane;
        }
    }
}

void draw_toon(void) /* 2003 */
{
    int i, j, k;

    for (j = 0; j < 41; j++) {
        for (k = 0; k < 2; k++) {
            for (i = 0; i < 8; i++) {
                if (toon[j] & 1 << (15-((1-k)*8+i)))
                  pBits[640*(399-(39+j+hmy))+240+k*8+i] |= 4;
            }
        }
    }
}

void draw_tensen(void) /* 2003 */
{
    int i;

    grcg_hline(243, 638, hmy+149+1);  /*  */
    for (i = 244; i <= 638; i=i+2) {
        pBits[640*(399-(hmy+149+1-17))+i] |= 4;  /* _ */
    }
}
